Imports System.Console
Public Class Trains

    Shared Sub Main()
    
        Dim StartChoice As String
        Dim EndChoice As String
        Dim TravelStops As Integer
        Dim AdultQuantity As Integer
        Dim ChildrenQuantity As Integer
        Dim TicketType As String
        Dim Rate As Decimal
        Dim rightNow As DateTime = DateTime.Now
        Dim Time As String

        Time = rightNow.ToString("H:mm")
        ForegroundColor = ConsoleColor.Red
        WriteLine("CURRENT TIME - " & Time)
        ForegroundColor = ConsoleColor.Gray
        WriteLine()

        WriteLine("How many ADULT tickets do you require?")
        AdultQuantity = ReadLine()
        WriteLine()
        WriteLine("How many CHILDREN tickets do you require?")
        ChildrenQuantity = ReadLine()
        WriteLine()
        WriteLine("What train station are you currently at (ENTER 3 CHARACTER ID)?")
        WriteLine("1. Walsall (WAL)")
        WriteLine("2. Birmingham New Street (BNS)")
        WriteLine("3. Birmingham International (BIN)")
        WriteLine("4. Coventry (COV)")
        WriteLine("5. Rugby (RUG)")
        WriteLine("6. Northampton (NOR)")
        WriteLine("7. Milton Keynes (MIL)")
        WriteLine("8. Watford (WAT)")
        WriteLine("9. London Euston (EUS)")
        StartChoice = ReadLine()
        WriteLine()
        StartChoice = StartChoice.ToUpper
        WriteLine("What train station are you traveling to? (ENTER 3 CHARACTER ID)")
        WriteLine("1. Walsall (WAL)")
        WriteLine("2. Birmingham New Street (BNS)")
        WriteLine("3. Birmingham International (BIN)")
        WriteLine("4. Coventry (COV)")
        WriteLine("5. Rugby (RUG)")
        WriteLine("6. Northampton (NOR)")
        WriteLine("7. Milton Keynes (MIL)")
        WriteLine("8. Watford (WAT)")
        WriteLine("9. London Euston (EUS)")
        EndChoice = ReadLine()
        WriteLine()
        EndChoice = EndChoice.ToUpper
        WriteLine("What type of ticket(s) do you require? (ENTER CHARACTER ID)")
        WriteLine("Single (S)")
        WriteLine("Return (R)")
        TicketType = ReadLine()
        WriteLine()
        TicketType = TicketType.ToUpper

        TravelStops = TravelStopsFunction(StartChoice, EndChoice)

        If TravelStops >= 1 And TravelStops <= 4 Then
            Rate = 1.85
        ElseIf TravelStops >= 5 And TravelStops <= 6 Then
            Rate = 2.6
        ElseIf TravelStops >= 7 Then
            Rate = 3.1
        End If

        Dim AdultTotal As Decimal
        Dim ChildTotal As Decimal
        Dim CurrHour As Integer
        Dim timeG As Date
        timeG = DateTime.Now
        CurrHour = timeG.Hour

        If TicketType = "S" Then
            AdultTotal = Rate * TravelStops * AdultQuantity
            Dim Discount As Decimal
            Discount = Rate * TravelStops * ChildrenQuantity
            ChildTotal = Discount - (12.5 / 100 * Discount)
        ElseIf TicketType = "R" Then
            Dim Discount As Decimal = 13 / 100 * (Rate * TravelStops * AdultQuantity)
            AdultTotal = (Rate * TravelStops * AdultQuantity) - Discount
            Discount = Rate * TravelStops * ChildrenQuantity
            ChildTotal = Discount - (25.5 / 100 * Discount)
        Else
            WriteLine("Invalid Selection")
        End If

        ForegroundColor = ConsoleColor.Green
        WriteLine("")
        WriteLine("- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -")
        If CurrHour <= 7 Or CurrHour >= 18 Then
            ChildTotal = ChildTotal - (25 / 100 * ChildTotal)
            AdultTotal = AdultTotal - (25 / 100 * AdultTotal)
            WriteLine("ADULT(S): " & AdultQuantity)
            WriteLine("CHILD(REN): " & ChildrenQuantity)
            WriteLine("CHILD TOTAL: £" & Math.Round(ChildTotal, 2))
            WriteLine("ADULT TOTAL: £" & Math.Round(AdultTotal, 2))
            WriteLine("OVERALL TOTAL: £" & Math.Round(AdultTotal + ChildTotal, 2))
        Else
            WriteLine("ADULT(S): " & AdultQuantity)
            WriteLine("CHILD(REN): " & ChildrenQuantity)
            WriteLine("CHILD TOTAL: £" & Math.Round(ChildTotal, 2))
            WriteLine("ADULT TOTAL: £" & Math.Round(AdultTotal, 2))
            WriteLine("OVERALL TOTAL: £" & Math.Round(AdultTotal + ChildTotal, 2))
        End If
        WriteLine("- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -")
        ReadLine()

    End Sub
    Shared Function TravelStopsFunction(ByVal StartStation As String, ByVal EndStation As String)
        Dim Stops As Integer
        If StartStation = "WAL" Then
            Select Case EndStation
                Case "BNS"
                    Stops = 1
                Case "BIN"
                    Stops = 2
                Case "COV"
                    Stops = 3
                Case "RUG"
                    Stops = 4
                Case "NOR"
                    Stops = 5
                Case "MIL"
                    Stops = 6
                Case "WAT"
                    Stops = 7
                Case "EUS"
                    Stops = 8
            End Select
        ElseIf StartStation = "BNS" Then
            Select Case EndStation
                Case "WAL"
                    Stops = 1
                Case "BIN"
                    Stops = 1
                Case "COV"
                    Stops = 2
                Case "RUG"
                    Stops = 3
                Case "NOR"
                    Stops = 4
                Case "MIL"
                    Stops = 5
                Case "WAT"
                    Stops = 6
                Case "EUS"
                    Stops = 7
            End Select
        ElseIf StartStation = "BIN" Then
            Select Case EndStation
                Case "WAL"
                    Stops = 2
                Case "BNS"
                    Stops = 1
                Case "COV"
                    Stops = 1
                Case "RUG"
                    Stops = 2
                Case "NOR"
                    Stops = 3
                Case "MIL"
                    Stops = 4
                Case "WAT"
                    Stops = 5
                Case "EUS"
                    Stops = 6
            End Select
        ElseIf StartStation = "COV" Then
            Select Case EndStation
                Case "WAL"
                    Stops = 3
                Case "BNS"
                    Stops = 2
                Case "BIN"
                    Stops = 1
                Case "RUG"
                    Stops = 1
                Case "NOR"
                    Stops = 2
                Case "MIL"
                    Stops = 3
                Case "WAT"
                    Stops = 4
                Case "EUS"
                    Stops = 5
            End Select
        ElseIf StartStation = "RUG" Then
            Select Case EndStation
                Case "WAL"
                    Stops = 4
                Case "BNS"
                    Stops = 3
                Case "BIN"
                    Stops = 2
                Case "COV"
                    Stops = 1
                Case "NOR"
                    Stops = 1
                Case "MIL"
                    Stops = 2
                Case "WAT"
                    Stops = 3
                Case "EUS"
                    Stops = 4
            End Select
        ElseIf StartStation = "NOR" Then
            Select Case EndStation
                Case "WAL"
                    Stops = 5
                Case "BNS"
                    Stops = 4
                Case "BIN"
                    Stops = 3
                Case "COV"
                    Stops = 2
                Case "RUG"
                    Stops = 1
                Case "MIL"
                    Stops = 1
                Case "WAT"
                    Stops = 2
                Case "EUS"
                    Stops = 3
            End Select
        ElseIf StartStation = "MIL" Then
            Select Case EndStation
                Case "WAL"
                    Stops = 6
                Case "BNS"
                    Stops = 5
                Case "BIN"
                    Stops = 4
                Case "COV"
                    Stops = 3
                Case "RUG"
                    Stops = 2
                Case "NOR"
                    Stops = 1
                Case "WAT"
                    Stops = 1
                Case "EUS"
                    Stops = 2
            End Select
        ElseIf StartStation = "WAT" Then
            Select Case EndStation
                Case "WAL"
                    Stops = 7
                Case "BNS"
                    Stops = 6
                Case "BIN"
                    Stops = 5
                Case "COV"
                    Stops = 4
                Case "RUG"
                    Stops = 3
                Case "NOR"
                    Stops = 2
                Case "MIL"
                    Stops = 1
                Case "EUS"
                    Stops = 1
            End Select
        ElseIf StartStation = "EUS" Then
            Select Case EndStation
                Case "WAL"
                    Stops = 8
                Case "BNS"
                    Stops = 7
                Case "BIN"
                    Stops = 6
                Case "COV"
                    Stops = 5
                Case "RUG"
                    Stops = 4
                Case "NOR"
                    Stops = 3
                Case "MIL"
                    Stops = 2
                Case "WAT"
                    Stops = 1
            End Select
        Else
            Stops = 0
        End If
        Return Stops
    End Function

End Class
